<template>
  <v-dialog
    v-if="size === 'compact'"
    v-model="dialog"
    :scrim="false"
    :absolute="true"
    class="top-10"
    :close-on-content-click="false"
    :contained="true"
  >
    <template #activator="{ props }">
      <svn-pro-icon-button
        v-bind="props"
        icon="custom:mingcute:link-line"
        variant="text"
        :color="editor.getAttributes('link').href ? 'primary' : 'onSurfaceVariant'"
      />
    </template>

    <template #default>
      <div class="w-full h-full bg-surface">
        <LinkEditorPanel
          :size="size"
          :initial-url="editor.getAttributes('link').href"
          :initial-open-in-new-tab="target === '_blank'"
          @on-set-link="onSetLink"
          @on-clear="onUnsetLink"
        />
      </div>
    </template>
  </v-dialog>

  <Popover v-else class="relative flex items-center justify-center">
    <PopoverButton>
      <svn-pro-icon-button
        icon="custom:mingcute:link-line"
        variant="text"
        :color="editor.getAttributes('link').href ? 'primary' : 'onSurfaceVariant'"
      />
    </PopoverButton>

    <PopoverPanel class="absolute z-10 top-10">
      <div class="w-full h-full bg-surface">
        <LinkEditorPanel
          :initial-url="editor.getAttributes('link').href"
          :initial-open-in-new-tab="target === '_blank'"
          @on-set-link="onSetLink"
          @on-clear="onUnsetLink"
        />
      </div>
    </PopoverPanel>
  </Popover>
</template>

<script setup>
import { Editor } from '@tiptap/vue-3';
import { watch, ref, onMounted } from 'vue';
import LinkEditorPanel from '../component/LinkEditorPanel.vue';
import SvnProIconButton from "../../button/SvnProIconButton.vue";
import { Popover, PopoverButton, PopoverPanel } from '@headlessui/vue';

onMounted(() => {
  showEdit.value = props.editor.isActive('link') ? props.editor.isActive('link') : false;
  editorRef.value = props.editor;
  link.value = props.editor.getAttributes('link').href;
  target.value = props.editor.getAttributes('link').target;
});

const props = defineProps({
  size: { type: String, default: null },
  elementTarget: { type: undefined, default: null },
  editor: { type: Editor, default: () => {}, required: true },
});

const emit = defineEmits(['edit-link']);

const link = ref('');
const target = ref('');
const dialog = ref(false);
const showEdit = ref(false);
const editorRef = ref(null);

const onSetLink = ({ url, openInNewTab }) => {
  props.editor.chain().focus().extendMarkRange('link').setLink({ href: url, target: openInNewTab ? '_blank' : '' }).run();
  showEdit.value = true;
}

const onUnsetLink = () => {
  props.editor.chain().focus().extendMarkRange('link').unsetLink().run();
  showEdit.value = false;
}

watch(props, (newValue, oldValue) => {
  if (newValue.editor) {
    editorRef.value = props.editor
    link.value = props.editor.getAttributes('link').href;
    target.value = props.editor.getAttributes('link').target;
  }
});

watch(link, (newValue, oldValue) => {
  if (newValue) {
    link.value = props.editor.getAttributes('link').href
    console.log(props.editor.getAttributes('link').href)
  }
});
</script>